import java.lang.reflect.Array;
import java.util.*;

public class Arraz<T> {

    public int sumValuesOfArray(int[] array) {
        int sum = 0;

        for (int intValue : array) {
            sum += intValue;
        }

        return sum;
    }

    public double sumDoubleOfArray(double[] array) {
        double sum = 0;

        for (double doubleValue : array) {
            sum += doubleValue;
        }

        return sum;
    }

    public int averageOfArray(int[] array) {
        return sumValuesOfArray(array) / array.length;
    }

    public double doubleAverageOfArray(double[] array) {
        return sumDoubleOfArray(array) / array.length;
    }

    public boolean containsValue(int[] array, int value) {
        for (int intValue : array) {
            if (intValue == value) {
                return true;
            }
        }
        return false;
    }

    public int[] reverseArray(int[] array) {
        int[] reverse = new int[array.length];
        int reverseIndex = array.length - 1;

        for (int intValue : array) {
            reverse[reverseIndex] = intValue;
            reverseIndex -= 1;
        }

        return reverse;
    }

    public OddEven getOddEvensOfArray(int[] array) {
        OddEven oddeven = new OddEven();

        for (int intValue : array) {
            if (intValue % 2 == 0) {
                oddeven.evens++;
            } else {
                oddeven.odds++;
            }
        }

        return oddeven;
    }

    public int findIndexOf(int[] array, int value) {
        for (int i = 0; i < array.length; i++) {
            if (array[i] == value) {
                return i;
            }
        }

        return -1;
    }

    public T[] createEmptyGenericArray(T[] array, int length) {
        Class cl = array.getClass();
        T[] copy = (T[]) Array.newInstance(cl.getComponentType(), length);

        return copy;
    }

    public T[] copyArrayByIterator(T[] array) {
        T[] copy = createEmptyGenericArray(array, array.length);
        int index = 0;

        List<T> copyList = Arrays.asList(array);
        Iterator iterator = copyList.iterator();

        while (iterator.hasNext()) {
            copy[index] = (T) iterator.next();
            index++;
        }

        return copy;
    }

    public T[] copyArrayByLoop(T[] array) {
        T[] copy = createEmptyGenericArray(array, array.length);

        for (int i = 0; i < array.length; i++) {
            copy[i] = array[i];
        }

        return copy;
    }

    public T[] removeElementFromArray(T[] array, T element) {
        T[] newArray = createEmptyGenericArray(array, array.length - 1);
        int j = 0;

        for (int i = 0; i < array.length; i++) {
            if (array[i] != element) {
                newArray[j] = array[i];
                j++;
            }
        }

        return newArray;
    }

    public T[] insertIntoArrayAt(T[] array, T element, int index) {
        T[] newArray = createEmptyGenericArray(array, array.length + 1);
        int j = 0;

        for (int i = 0; i < newArray.length; i++) {
            if (i != index) {
                newArray[i] = array[j];
                j++;
            } else if (i == index) {
                newArray[index] = element;
            }
        }

        return newArray;
    }

    public int findMax(int[] array) {
        int max = array[0];

        for (int intValue : array) {
            if (intValue > max) {
                max = intValue;
            }
        }

        return max;
    }

    public int findMin(int[] array) {
        int min = array[0];

        for (int intValue : array) {
            if (intValue < min) {
                min = intValue;
            }
        }

        return min;
    }

    public MaxMin findMaxMinOfArray(int[] array) {
        MaxMin maxMin = new MaxMin();
        maxMin.max = findMax(array);
        maxMin.min = findMin(array);

        return maxMin;
    }

    public Integer[] removeDupesFromArray(Integer[] array) {
        List<Integer> noDupes = new ArrayList<>();

        for (Integer integer : array) {
            if (!noDupes.contains(integer)) {
                noDupes.add(integer);
            }
        }

        Integer[] newArray = new Integer[noDupes.size()];
        int index = 0;

        for (Integer integer : noDupes) {
            newArray[index] = integer;
            index++;
        }

        return newArray;
    }

    public Double findLargest(Double[] array) {
        Double largest = array[0];

        for (int i = 0; i < array.length; i++) {
            for (int j = i + 1; j < array.length; j++) {
                if (largest < array[j]) {
                    largest = array[j];
                }
            }
        }

        return largest;
    }

    public int findIndexOfLargest(Double[] array) {
        Double largest = findLargest(array);
        int indexOfLargest = 0;

        for (int i = 0; i < array.length; i++) {
            if (array[i] == largest) {
                indexOfLargest = i;
            }
        }

        return indexOfLargest;
    }

    public Double find2ndLargestValueFromArray(Double[] array) {
        int indexOfLargest = findIndexOfLargest(array);
        array[indexOfLargest] = 0.0;

        return findLargest(array);
    }

    public ArrayList<T> makeMeAnArrayListFromArray(T[] array) {
        ArrayList<T> arrayList = new ArrayList<T>();

        for (T element : array) {
            arrayList.add(element);
        }

        return arrayList;
    }

    public T[] makeMeAnArrayFromArrayList(ArrayList<T> arrayList, T[] targetClass) {
        T[] newArray = createEmptyGenericArray((targetClass), arrayList.size());
        int index = 0;

        for (Object object : arrayList) {
            newArray[index] = (T) object;
            index++;
        }

        return newArray;
    }

    public boolean check2ArraysForEquals(T[] array1, T[] array2) {
        if (Arrays.equals(array1, array2)) {
            return true;
        }
        return false;
    }

    public double averageArrayWithoutMaxMin(int[] array) {
        double sum = 0;
        int dupes = 0;

        for (int integer : array) {
            if (integer != findMax(array) && integer != findMin(array)) {
                sum += integer;
            } else {
                dupes++;
            }
        }

        return sum / (array.length - dupes);
    }

    public boolean arrayHas65And77(int[] array) {
        if (containsValue(array, 65) && containsValue(array, 77)) {
            return true;
        }

        return false;
    }

    public boolean theTotalofTensIs30(int[] array) {
        int sum = 0;

        for (int integer : array) {
            if (integer == 10) {
                sum += integer;
            }
        }

        if (sum == 30) {
            return true;
        }

        return false;
    }


    public int findSmallestOfArray(int[] array) {
        return findMin(array);
    }

    public int findSecondSmallestOfArray(int[] array) {
        int indexOfSmallest = findIndexOf(array, findSmallestOfArray(array));
        array[indexOfSmallest] = findMax(array);

        return findMin(array);
    }

    public int[] makeMeACopyPlease(int[] array) {
        return reverseArray(array);
    }

    public T[] removeFromIndex(T[] array, int index) {
        T[] newArray = createEmptyGenericArray(array, array.length - 1);
        int j = 0;

        for (int i = 0; i < array.length; i++) {
            if (i != index) {
                newArray[j] = array[i];
                j++;
            }
        }
        return newArray;
    }

    public T[] removeLastItemAndCopy(T[] array) {
        T[] newArray = removeFromIndex(array, array.length - 1);

        return newArray;
    }

    public T[] removeFirstItemAndCopy(T[] array) {
        T[] newArray = removeFromIndex(array, 0);

        return newArray;
    }

    public T[] insertAtStartAndCopy(T[] array, T element) {
        T[] newArray = insertIntoArrayAt(array, element, 0);

        return newArray;
    }

    public T[] insertAtEndAndCopy(T[] array, T element) {
        T[] newArray = insertIntoArrayAt(array, element, array.length);

        return newArray;
    }

    public ArrayList<Integer> sortArrayIntoEvensThenOdds(int[] array) {
        ArrayList<Integer> arrayList = new ArrayList<>();
        int indexOfEvens = 0;

        for (int integer: array) {
            if (integer % 2 ==0) {
                arrayList.add(indexOfEvens, integer);
                indexOfEvens++;
            } else {
                arrayList.add(integer);
            }
        }

        return arrayList;
    }

}
